# wxControl Class Reference
[Controls]

`#include <wx/control.h>`

Inheritance diagram for wxControl:
[legend]

## Detailed Description

This is the base class for a control or "widget".

A control is generally a small window which processes user input and/or displays one or more item of data.

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxClipboardTextEvent& event)
Event macros for events emitted by this class:

- EVT_TEXT_COPY(id, func):
  Some or all of the controls content was copied to the clipboard.
- EVT_TEXT_CUT(id, func):
  Some or all of the controls content was cut (i.e. copied and deleted).
- EVT_TEXT_PASTE(id, func):
  Clipboard content was pasted into the control.

##

Library: wxCore

Category: Controls

See also:
  wxValidator

## Public Member Functions
virtual void | Command (wxCommandEvent &event)
| Simulates the effect of the user issuing a command to the item.
wxString | GetLabel () const
| Returns the control's label, as it was passed to SetLabel().
wxString | GetLabelText () const
| Returns the control's label without mnemonics.
void | SetLabel (const wxString &label)
| Sets the control's label.
void | SetLabelText (const wxString &text)
| Sets the control's label to exactly the given string.
bool | SetLabelMarkup (const wxString &markup)
| Sets the controls label to a string using markup.
## Static Public Member Functions
static wxString | GetLabelText (const wxString &label)
| Returns the given label string without mnemonics ("&" characters).
static wxString | RemoveMnemonics (const wxString &str)
| Returns the given str string without mnemonics ("&" characters).
static wxString | EscapeMnemonics (const wxString &text)
| Escapes the special mnemonics characters ("&") in the given string.
static wxString | Ellipsize (const wxString &label, const wxDC &dc, wxEllipsizeMode mode, int maxWidth, int flags=wxELLIPSIZE_FLAGS_DEFAULT)
| Replaces parts of the label string with ellipsis, if needed, so that it fits into maxWidth pixels if possible.

List of all members.

## Member Function Documentation

virtual void wxControl::Command | ( | wxCommandEvent & | event | ) | `[virtual]`

Simulates the effect of the user issuing a command to the item.

See also:
  wxCommandEvent

Reimplemented in wxRichTextCtrl.

static wxString wxControl::Ellipsize | ( | const wxString & | label,
|  | const wxDC & | dc,
|  | wxEllipsizeMode | mode,
|  | int | maxWidth,
|  | int | flags = `wxELLIPSIZE_FLAGS_DEFAULT` |
| ) |  |  | `[static]`

Replaces parts of the label string with ellipsis, if needed, so that it fits into maxWidth pixels if possible.

Note that this function does not guarantee that the returned string will always be shorter than maxWidth; if maxWidth is extremely small, ellipsized text may be larger.

Parameters:

  | label | The string to ellipsize
  | dc | The DC used to retrieve the character widths through the wxDC::GetPartialTextExtents() function.
  | mode | The ellipsization mode. This is the setting which determines which part of the string should be replaced by the ellipsis. See wxEllipsizeMode enumeration values for more info.
  | maxWidth | The maximum width of the returned string in pixels. This argument determines how much characters of the string need to be removed (and replaced by ellipsis).
  | flags | One or more of the wxEllipsizeFlags enumeration values combined.

static wxString wxControl::EscapeMnemonics | ( | const wxString & | text | ) | `[static]`

Escapes the special mnemonics characters ("&") in the given string.

This function can be helpful if you need to set the controls label to a user-provided string. If the string contains ampersands, they wouldn't appear on the display but be used instead to indicate that the character following the first of them can be used as a control mnemonic. While this can sometimes be desirable (e.g. to allow the user to configure mnemonics of the controls), more often you will want to use this function before passing a user-defined string to SetLabel(). Alternatively, if the label is entirely user-defined, you can just call SetLabelText() directly -- but this function must be used if the label is a combination of a part defined by program containing the control mnemonics and a user-defined part.

Parameters:

  | text | The string such as it should appear on the display.

Returns:
  The same string with the ampersands in it doubled.

wxString wxControl::GetLabel | ( |  | ) | const`[virtual]`

Returns the control's label, as it was passed to SetLabel().

Note that the returned string may contains mnemonics ("&" characters) if they were passed to the SetLabel() function; use GetLabelText() if they are undesired.

Also note that the returned string is always the string which was passed to SetLabel() but may be different from the string passed to SetLabelText() (since this last one escapes mnemonic characters).

Reimplemented from wxWindow.

Reimplemented in wxButton, and wxCommandLinkButton.

static wxString wxControl::GetLabelText | ( | const wxString & | label | ) | `[static]`

Returns the given label string without mnemonics ("&" characters).

wxString wxControl::GetLabelText | ( |  | ) | const

Returns the control's label without mnemonics.

Note that because of the stripping of the mnemonics the returned string may differ from the string which was passed to SetLabel() but should always be the same which was passed to SetLabelText().

static wxString wxControl::RemoveMnemonics | ( | const wxString & | str | ) | `[static]`

Returns the given str string without mnemonics ("&" characters).

Note:
  This function is identical to GetLabelText() and is provided mostly for symmetry with EscapeMnemonics().

void wxControl::SetLabel | ( | const wxString & | label | ) | `[virtual]`

Sets the control's label.

All "&" characters in the label are special and indicate that the following character is a mnemonic for this control and can be used to activate it from the keyboard (typically by using Alt key in combination with it). To insert a literal ampersand character, you need to double it, i.e. use "&&". If this behaviour is undesirable, use SetLabelText() instead.

Reimplemented from wxWindow.

Reimplemented in wxButton, and wxCommandLinkButton.

bool wxControl::SetLabelMarkup | ( | const wxString & | markup | ) |

Sets the controls label to a string using markup.

Simple markup supported by this function can be used to apply different fonts or colours to different parts of the control label when supported. If markup is not supported by the control or platform, it is simply stripped and SetLabel() is used with the resulting string.

For example,

                wxStaticText *text;
                ...
                text->SetLabelMarkup("<b>&amp;Bed</b> &amp;mp; "
                                     "<span foreground='red'>breakfast</span> "
                                     "available <big>HERE</big>");

would show the string using bold, red and big for the corresponding words under wxGTK but will simply show the string "Bed & breakfast available HERE" on the other platforms. In any case, the "B" of "Bed" will be underlined to indicate that it can be used as a mnemonic for this control.

The supported tags are:

Tag | Description
<b> | bold text
<big> | bigger text
<i> | italic text
<s> | strike-through text
<small> | smaller text
<tt> | monospaced text
<u> | underlined text
<span> | generic formatter tag, see the table below for supported attributes.

Supported `<span>` attributes:

Name | Description
foreground, fgcolor, color | Foreground text colour, can be a name or RGB value.
background, bgcolor | Background text colour, can be a name or RGB value.
font_family, face | Font face name.
font_weight, weight | Numeric value in 0..900 range or one of "ultralight", "light", "normal" (all meaning non-bold), "bold", "ultrabold" and "heavy" (all meaning bold).
font_style, style | Either "oblique" or "italic" (both with the same meaning) or "normal".
size | The font size can be specified either as "smaller" or "larger" relatively to the current font, as a CSS font size name ("xx-small", "x-small", "small", "medium", "large", "x-large" or "xx-large") or as a number giving font size in 1024th parts of a point, i.e. 10240 for a 10pt font.

This markup language is a strict subset of Pango markup (described at http://library.gnome.org/devel/pango/unstable/PangoMarkupFormat.html) and any tags and span attributes not documented above can't be used under non-GTK platforms.

Also note that you need to escape the following special characters:

Special character | Escape as
`&` | `&amp`; or as `&&`
`'` | `&apos`;
`"` | `&quot`;
`<` | `&lt`;
`>` | `&gt`;

The non-escaped ampersand `&` characters are interpreted as mnemonics as with wxControl::SetLabel.

Parameters:

  | markup | String containing markup for the label. It may contain markup tags described above and newline characters but currently only wxGTK and wxOSX support multiline labels with markup, the generic implementation (also used in wxMSW) only handles single line markup labels. Notice that the string must be well-formed (e.g. all tags must be correctly closed) and won't be shown at all otherwise.

Returns:
  true if the new label was set (even if markup in it was ignored) or false if we failed to parse the markup. In this case the label remains unchanged.

Currently wxButton supports markup in all major ports (wxMSW, wxGTK and wxOSX/Cocoa) while wxStaticText supports it in wxGTK and wxOSX and its generic version (which can be used under MSW if markup support is required). Extending support to more controls is planned in the future.

Since:
  2.9.2

void wxControl::SetLabelText | ( | const wxString & | text | ) |

Sets the control's label to exactly the given string.

Unlike SetLabel(), this function shows exactly the text passed to it in the control, without interpreting ampersands in it in any way. Notice that it means that the control can't have any mnemonic defined for it using this function.

See also:
  EscapeMnemonics()

|  | [ top ]